     //    *****************************************************************************************
     //         Nom : Somtochukwu Frank Ibekwe    code permenant : IBES64270300
     //
     //         Nom : Thierno Mamadou Diallo      code permenant : DIAT73090000
     //
     //         Nom : Meuleye Fomo Stephane       code permenant : MEUA05059900
     //
     //    *****************************************************************************************


#include <stdio.h>
#include <stdbool.h>
#include <math.h>

/* 

  Déclaration des termes à utiliser pour la fonction division
    a represente le dividende
    b represente le diviseur
    c represente le quotient
    d represente le restant
    N represente le nombre entier naturrel 

*/

// Fonction de division
//La fonction de division est une opération qui retourne une structure contenant le quotient et le reste d'une division entière

unsigned short int division(unsigned short int a, unsigned short int b);

int main() {
    int N;

    // Demande à l'utilisateur le nombre de divisions à effectuer
    printf("Entrez le nombre de divisions à effectuer : ");
    scanf("%d", &N);

    // Ouverture du fichier de sortie
    FILE *fichier_sortie = fopen("resultats.txt", "w");

    // Vérification que le fichier a été ouvert avec succès
    if (fichier_sortie == NULL) {
        printf("Impossible d'ouvrir le fichier de sortie.\n");
        return 1;
    }

    // Boucle pour chaque division à effectuer
    for (int i = 0; i < N; i++) {
        unsigned short int a, b, c, d;

        // Saisie du dividende
        printf("Entrez le dividende pour la division %d (entre 0 et 65535) : ", i + 1);
        scanf("%hu", &a);

        // Vérification que le dividende est valide
        if (a > 65535) {
            printf("Le dividende doit être compris entre 0 et 65535.\n");
            return 1;
        }

        // Saisie du diviseur
        printf("Entrez le diviseur pour la division %d (entre 1 et 65535) : ", i + 1);
        scanf("%hu", &b);

        // Vérification que le diviseur est valide
        if (b < 1 || b > 65535) {
            printf("Le diviseur doit être compris entre 1 et 65535.\n");
            return 1;
        }

        // Calcul du quotient et du reste
        c = division(a, b);
        d = a % b;

        // Écriture des résultats dans le fichier de sortie
        fprintf(fichier_sortie, "Division %d sur %d: %hu / %hu = %hu reste %hu\n", i + 1, N, a, b, c, d);
    }

    // Fermeture du fichier de sortie
    fclose(fichier_sortie);
    printf("Les résultats ont été écrits dans le fichier 'resultats.txt'.\n");

    return 0;
}

// Fonction de division utilisant la méthode de division binaire par restauration des restes partiels
//Elle utilise des opérations de décalage, d'addition et de soustraction pour diviser deux nombres binaires, 
//en vérifiant itérativement si le diviseur peut être soustrait du dividende à chaque itération.

unsigned short int division(unsigned short int a, unsigned short int b) {
    unsigned short int quotient = 0;

    for (int i = 15; i >= 0; i--) {
        quotient <<= 1;
        if ((a >> i) >= b) {
            a -= b << i;
            quotient |= 1;
        }
    }

    return quotient;
}