/*
 ====================================================================================================
             TP2 : Architecture des ordinateurs
 Auteurs : [Ehui Assama : EHUA90530000],
           [Diomande Mahoua Ilma : DIOM92300400],
           [Alimatou Sow: Sowa84330100],
           [Houé Dicardie Precious Netty:HOUD72560400],
 =====================================================================================================
 */
#include <stdio.h>

/*
 * division : Effectue une division entière entre deux nombres de 16 bits.
 * Paramètres :
 *   - dividende : le nombre à diviser (type : unsigned short int, passage : par valeur)
 *   - diviseur : le nombre par lequel diviser (type : unsigned short int, passage : par valeur)
 * Retour :
 *   - Le résultat de la division entière (type : unsigned short int)
 */

unsigned short int division(unsigned short int dividende, unsigned short int diviseur) {
    if (diviseur == 0) {
        printf("Erreur : Division par zéro.\n");
        return 0;
    }

    unsigned short int quotient = 0;
    unsigned short int reste = 0;
    int i;

for (i = 15; i >= 0; i--) {
        reste <<= 1;
        reste |= (dividende >> i) & 1;

        if (reste >= diviseur) {
            reste -= diviseur;
            quotient |= 1 << i;
        }
    }

    return quotient;
}

/*
 * main : Fonction principale du programme. Effectue des divisions entières entre des nombres de 16 bits.
 *               Les résultats sont affichés à l'écran et écrits dans un fichier "resultat.txt".
 *               L'utilisateur est invité à saisir le nombre de divisions à effectuer ainsi que les valeurs des dividende et diviseur pour chaque division.
 * Retour : 0 si le programme s'est exécuté correctement, 1 en cas d'erreur
 */

int main() {
    unsigned short int nombreDivisions;
    FILE* resultat;
    
    resultat = fopen("resultat.txt", "w"); // ouverture du fichier en mode écriture
    
    if (resultat == NULL) {
        printf("Erreur lors de l'ouverture du fichier.\n");
        return 1; // Quitter le programme avec un code d'erreur
    }

    printf("Entrez le nombre de divisions à effectuer : ");
    scanf("%hu", &nombreDivisions);

    for (unsigned short int i = 0; i < nombreDivisions; i++) {
        unsigned short int dividende, diviseur;
        printf("Division %hu :\n", i + 1);

        do {
            printf("Entrez la valeur du dividende (entre 0 et 65535) : ");
            scanf("%hu", &dividende);
        } while (dividende < 0 || dividende > 65535);

        do {
            printf("Entrez la valeur du diviseur (entre 1 et 65535) : ");
            scanf("%hu", &diviseur);
        } while (diviseur < 1 || diviseur > 65535);

        unsigned short int resultatDivision = division(dividende, diviseur);
        printf("Résultat de la division : %hu\n", resultatDivision);

        fprintf(resultat, "La division %hu : %hu / %hu = %hu il reste %hu\n", i + 1, dividende, diviseur, resultatDivision, dividende % diviseur);
    }
    fclose(resultat); // fermeture du fichier
    printf("Les résultats et les restes ont été écrits dans le fichier.\n");
    
    return 0; // Indiquer que le programme s'est exécuté correctement
}
