/*
     #MEMBRES DU GROUPE                  Code Permanent
     ISSA OUMAROU EL HADJI               OUMI25129901
     HALIROU AOUDOU MIDOU                AOUH63260000
     LINDSAY GABRIELLE TENE SIDJE        TENL78270200
     NURUDEEN ABIOLA FASHOLA             NURA25349801
*/


#include <stdio.h> 
#include <limits.h>


unsigned int division (unsigned short dividende, unsigned short diviseur); 

//fonction principale de notre programme
int main (){
    unsigned short dividende, diviseur;
    unsigned int resultat;
    int n,nombre;
    FILE *fichier; //fichier que nous allons utiliser pour ecrire le resultat

    //ouverture du fichier en ecriture
    fichier = fopen ("resultat.txt", "w");

    if ( fichier == NULL ){     //cette condition verifie si le fichier existe et renvoie un message si le fichier n'existe pas
        printf ("Aucun fichier trouve.\n");
        return 1;
    }
    //ici on demande a l'utilisateur d'entrer le nombre de division qu'il souhaite effectuer
    printf ("Donnez le nombre de division a effectuer \n");
    scanf ("%d",&nombre);

    //cette boucle execute notre fonction division un nombre de fois qui aura ete choisi par l'utilisateur
    for ( int i=0; i<nombre; i++ )
            {
                //cette boucle s'assure que la valeur du dividende est bien un unsigned short int 
        while ( 1 ){
            printf("donnez la valeur du dividende entre 0 et %hu \n",SHRT_MAX);
            scanf("%d",&n);
            if ( n >= 0 && n <= SHRT_MAX ){
                dividende = ( unsigned short )n;
                printf("vous avez entre :%hu \n",dividende);
                break;
            }
            else {
                printf("Erreur de valeur \n");

            } 
    }           //cette boucle s'assure que la valeur du diviseur est bien un unsigned short int 
        while ( 1 ){
            printf("donnez la valeur du diviseur entre 1 et %hu \n",SHRT_MAX);
            scanf("%d",&n);
            if ( n >0 && n <= SHRT_MAX ){
                diviseur = ( unsigned short )n;
                printf("vous avez entre :%hu \n",diviseur);
                break;
            }
            else {
                printf("Erreur de valeur \n");

            } 
    }
                //appel de la fonction division et resultat stocké dans la variable resultat
            resultat = division ( dividende, diviseur );

                /*
                 *resultat&65535 operateur bitwise AND entre la variable resultat et le masque 65525 qui represente 16 bits a 1
                 en gros on recupere les 16 bits de poids faible de notre resultat 

                 resultat>>16 ici on effectue un decalage de 16 bits vers la gauche sur la variable resultat 
                 donc les 16 bits de poids fort du resultat ou on avait stocke la valeur du dividende a la fin de la 
                 dernier iteration est decallé vers la gauche pour avoir la valeur du reste
                */
            printf (" DIVISION %d :\nle resultat de la division  %hu / %hd est quotient : %u \t reste : %u \n",i+1 ,dividende, diviseur, resultat&65535, resultat>>16);
            fprintf (fichier, "Division %d :\n %hu / %hu = %u (quotient) \t reste : %u \n",i+1, dividende, diviseur, resultat&65535, resultat>>16);
            }

    return 0;
}


/**
 * Fonction de division binaire par restauration de reste partiel
 * @param dividende : entier non signier sur 16 bits qui sera notre numerateur
 * @param diviseur : entier non signier sur 16 bits qui sera notre denominateur
 * 
 * cette fonction va prendre en parametre deux unsigned short int: un dividende et l'autre le diviseur
 * et retourne un resultat qui est un entier sur 32 bits
 * A chaque iteration, la fonction verifie si le dividende est superieur ou egale au diviseur 
 * si c'est le cas, la valeur du diviseur est soustraite du dividende et le quotient est incrementé
 * a la derniere iteration (dividende < diviseur), 
 * la valeur du quotient est stockée dans la partie basse de resultat (16 bits de poids faible)
 * la valeur de dividende (dividende < diviseur) est stockée à la partie haute de resultat (16 bits de poids fort)
*/
unsigned int division ( unsigned short dividende, unsigned short diviseur ){

    unsigned short int quotient = 0;
    unsigned int resultat;

    while ( dividende >= diviseur ){
        dividende -= diviseur;
        quotient++;
    }
    resultat = quotient;
    resultat += ( dividende <<16 ); 



    return resultat;
}