#include <stdio.h>

// Fonction de division
unsigned int division(unsigned int dividend, unsigned int divisor, unsigned int *remainder) {
    unsigned int quotient = 0;
    *remainder = 0;

    // Vérifier si le diviseur est égal à zéro
    if (divisor == 0) {
        printf("Erreur: Division par zéro\n");
        return 0;
    }

    // Division binaire par restauration des restes partiels
    for (int i = 15; i >= 0; i--) {
        *remainder <<= 1;
        *remainder |= (dividend >> i) & 1;
        quotient <<= 1;
        if (*remainder >= divisor) {
            *remainder -= divisor;
            quotient |= 1;
        }
    }

    return quotient;
}

int main() {
    int num_divisions;
    printf("Entrez le nombre de divisions à effectuer : ");
    scanf("%d", &num_divisions);

    for (int i = 1; i <= num_divisions; i++) {
        unsigned int dividend, divisor, remainder;
        printf("Entrez le dividende pour la division %d : ", i);
        scanf("%u", &dividend);
        printf("Entrez le diviseur pour la division %d : ", i);
        scanf("%u", &divisor);

        unsigned int quotient = division(dividend, divisor, &remainder);
        printf("Division %d: %u / %u = %u reste %u\n", i, dividend, divisor, quotient, remainder);
    }

    return 0;
}