// prenom et nom: Mohamed Heni Baabaa            code permaneant: BAAM79260100
// prenom et nom: Ahmed Ammar                    code permaneant: AMMA66290400
// prenom et nom: Mohamed Oussama Tazniti        code permaneant: TAZM84280400
// prenom et nom: Ayman Soufaih                  code permaneant: SOUA70270100

#include <stdio.h>

// Title: division
// Description: Cette fonction effectue la division de deux nombres entiers positifs en utilisant la méthode de division binaire par restauration des restes partiels.
// Parameters:
//   - dividende (unsigned int) : Le dividende de la division.
//   - diviseur (unsigned int) : Le diviseur de la division.
// Return: Le résultat de la division, représentant le reste et le quotient combinés dans un entier non signé.
unsigned int division(unsigned int dividende, unsigned int diviseur)
{
    diviseur = diviseur << 16; // Décalage du diviseur pour le mettre sur 16 bits
    for (unsigned int i = 0; i < 16; i++)
    {
        dividende = dividende << 1; // Décalage du dividende à gauche
        if (dividende >= diviseur)
        {
            dividende = dividende - diviseur;
            dividende = dividende + 1;
        }
    }
    return dividende; // Retourne le résultat de la division (le reste et le quotient combinés)
}

int main()
{
    unsigned int dividende, diviseur, resultat, quotient, reste;
    int i, n;
    printf("Entrez le nombre de divisions a effectuer : ");
    scanf("%d", &n);
    FILE *rep;
    rep = fopen("reponse.txt", "w");
    for (i = 0; i < n; i++)
    {
        do
        {
            printf("Entrez le dividende (entre 0 et 65535) : de la division %d : ", i + 1);
            scanf("%u", &dividende);
        } while (dividende < 1 || dividende > 65535); // Vérifie que le dividende est dans la plage valide

        do
        {
            printf("Entrez le diviseur (entre 1 et 65535) de la division %d : ", i + 1);
            scanf("%u", &diviseur);
        } while (diviseur < 1 || diviseur > 65535); // Vérifie que le diviseur est dans la plage valide

        resultat = division(dividende, diviseur); // Appel de la fonction de division
        quotient = resultat & 0xFFFF;             // Extraction du quotient à partir du résultat (les 16 premiers bits)
        reste = resultat >> 16;                   // Extraction du reste à partir du résultat (les 16 derniers bits)
        // Écriture des résultats dans le fichier
        fprintf(rep, "Division %d: %u / %u = %u reste %u\n", i + 1, dividende, diviseur, quotient, reste);
    }
    fclose(rep);
    printf("Les resultats ont ete ecrits dans le fichier reponse.txt\n");
    return 0;
}